DCMTK: DSRTemporalCoordinatesValue Class Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Private Attributes | Friends | List of all members
DSRTemporalCoordinatesValue Class Reference

Class for temporal coordinates values. More...

Inheritance diagram for DSRTemporalCoordinatesValue:

## Public Member Functions
| DSRTemporalCoordinatesValue ()
| default constructor
| DSRTemporalCoordinatesValue (const DSRTypes::E_TemporalRangeType temporalRangeType)
| constructor
| DSRTemporalCoordinatesValue (const DSRTemporalCoordinatesValue &coordinatesValue)
| copy constructor
virtual | ~DSRTemporalCoordinatesValue ()
| destructor
DSRTemporalCoordinatesValue & | operator= (const DSRTemporalCoordinatesValue &coordinatesValue)
| assignment operator
virtual void | clear ()
| clear all internal variables.
OFBool | isEqual (const DSRTemporalCoordinatesValue &coordinatesValue) const
| check whether values are "equal"
OFBool | isNotEqual (const DSRTemporalCoordinatesValue &coordinatesValue) const
| check whether values are "not equal"
virtual OFBool | isValid () const
| check whether the current temporal coordinates value is valid.
virtual OFBool | isShort (const size_t flags) const
| check whether the content is short.
virtual OFCondition | print (STD_NAMESPACE ostream &stream, const size_t flags) const
| print temporal coordinates.
virtual OFCondition | readXML (const DSRXMLDocument &doc, DSRXMLCursor cursor, const size_t flags)
| read temporal coordinates value from XML document
virtual OFCondition | writeXML (STD_NAMESPACE ostream &stream, const size_t flags) const
| write temporal coordinates value in XML format
virtual OFCondition | renderHTML (STD_NAMESPACE ostream &docStream, STD_NAMESPACE ostream &annexStream, size_t &annexNumber, const size_t flags) const
| render temporal coordinates value in HTML/XHTML format
const DSRTemporalCoordinatesValue & | getValue () const
| get reference to temporal coordinates value
OFCondition | getValue (DSRTemporalCoordinatesValue &coordinatesValue) const
| get copy of temporal coordinates value
OFCondition | setValue (const DSRTemporalCoordinatesValue &coordinatesValue, const OFBool check=OFTrue)
| set temporal coordinates value.
DSRTypes::E_TemporalRangeType | getTemporalRangeType () const
| get current temporal range type.
OFCondition | setTemporalRangeType (const DSRTypes::E_TemporalRangeType temporalRangeType, const OFBool check=OFTrue)
| set current temporal range type.
DSRReferencedDateTimeList & | getDateTimeList ()
| get reference to list of referenced date/time
DSRReferencedSamplePositionList & | getSamplePositionList ()
| get reference to list of referenced sample positions
DSRReferencedTimeOffsetList & | getTimeOffsetList ()
| get reference to list of referenced time offsets

## Protected Member Functions
DSRTemporalCoordinatesValue * | getValuePtr ()
| get pointer to temporal coordinates value
virtual OFCondition | read (DcmItem &dataset, const size_t flags)
| read temporal coordinates value from dataset.
virtual OFCondition | write (DcmItem &dataset) const
| write temporal coordinates reference value to dataset.
OFCondition | checkData (const DSRTypes::E_TemporalRangeType temporalRangeType, const DSRReferencedSamplePositionList &samplePositionList, const DSRReferencedTimeOffsetList &timeOffsetList, const DSRReferencedDateTimeList &dateTimeList, const OFBool reportWarnings=OFFalse) const
| check the temporal range type and other data for validity.

## Private Attributes
DSRTypes::E_TemporalRangeType | TemporalRangeType
| temporal range type (associated DICOM VR=CS, type 1)
DSRReferencedSamplePositionList | SamplePositionList
| list of referenced sample positions (associated DICOM VR=UL, VM=1-n, type 1C)
DSRReferencedTimeOffsetList | TimeOffsetList
| list of referenced time offsets (associated DICOM VR=DS, VM=1-n, type 1C)
DSRReferencedDateTimeList | DateTimeList
| list of referenced date/time (associated DICOM VR=DT, VM=1-n, type 1C)

## Friends
class | DSRContentItem

## Detailed Description

Class for temporal coordinates values.

## Constructor & Destructor Documentation

## ◆ DSRTemporalCoordinatesValue() [1/2]

DSRTemporalCoordinatesValue::DSRTemporalCoordinatesValue | ( | const DSRTypes::E_TemporalRangeType | temporalRangeType | ) |

constructor

Parameters

  temporalRangeType | type of temporal extent of the region of interest

## ◆ DSRTemporalCoordinatesValue() [2/2]

DSRTemporalCoordinatesValue::DSRTemporalCoordinatesValue | ( | const DSRTemporalCoordinatesValue & | coordinatesValue | ) |

copy constructor

Parameters

  coordinatesValue | temporal coordinates value to be copied (not checked !)

References DSRTemporalCoordinatesValue().

## Member Function Documentation

## ◆ checkData()

OFCondition DSRTemporalCoordinatesValue::checkData | ( | const DSRTypes::E_TemporalRangeType | temporalRangeType,
|  | const DSRReferencedSamplePositionList & | samplePositionList,
|  | const DSRReferencedTimeOffsetList & | timeOffsetList,
|  | const DSRReferencedDateTimeList & | dateTimeList,
|  | const OFBool | reportWarnings = OFFalse ) const
| protected

check the temporal range type and other data for validity.

The data is valid if the 'temporalRangeType' is valid and at least one of the three lists are non-empty. If more than one list is non-empty, a warning is reported (if enabled) since they are mutually exclusive (type 1C).

Parameters

  temporalRangeType | temporal range type to be checked
  samplePositionList | list of referenced sample positions to be checked
  timeOffsetList | list of referenced time offsets to be checked
  dateTimeList | list of referenced date/time to be checked
  reportWarnings | if enabled, report a warning message on each deviation from an expected value to the logger

Returns
  status, EC_Normal if checked data is valid, an error code otherwise

## ◆ clear()

virtual void DSRTemporalCoordinatesValue::clear | ( |  | ) |
| virtual

clear all internal variables.

Temporal range type is set to DSRTypes::TRT_invalid. Since an empty list of graphic data is invalid the temporal coordinates value becomes invalid afterwards.

Reimplemented in DSRTCoordTreeNode.

## ◆ getDateTimeList()

DSRReferencedDateTimeList & DSRTemporalCoordinatesValue::getDateTimeList | ( |  | ) |
| inline

get reference to list of referenced date/time

Returns
  reference to list

References DateTimeList.

## ◆ getSamplePositionList()

DSRReferencedSamplePositionList & DSRTemporalCoordinatesValue::getSamplePositionList | ( |  | ) |
| inline

get reference to list of referenced sample positions

Returns
  reference to list

References SamplePositionList.

## ◆ getTemporalRangeType()

DSRTypes::E_TemporalRangeType DSRTemporalCoordinatesValue::getTemporalRangeType | ( |  | ) | const
| inline

get current temporal range type.

This value represents the type of temporal extent of the region of interest.

Returns
  region type (might be DSRTypes::TRT_invalid)

References TemporalRangeType.

## ◆ getTimeOffsetList()

DSRReferencedTimeOffsetList & DSRTemporalCoordinatesValue::getTimeOffsetList | ( |  | ) |
| inline

get reference to list of referenced time offsets

Returns
  reference to list

References TimeOffsetList.

## ◆ getValue() [1/2]

const DSRTemporalCoordinatesValue & DSRTemporalCoordinatesValue::getValue | ( |  | ) | const
| inline

get reference to temporal coordinates value

Returns
  reference to temporal coordinates value

References DSRTemporalCoordinatesValue().

## ◆ getValue() [2/2]

OFCondition DSRTemporalCoordinatesValue::getValue | ( | DSRTemporalCoordinatesValue & | coordinatesValue | ) | const

get copy of temporal coordinates value

Parameters

  coordinatesValue | reference to variable in which the value should be stored

Returns
  status, EC_Normal if successful, an error code otherwise

References DSRTemporalCoordinatesValue().

## ◆ getValuePtr()

DSRTemporalCoordinatesValue * DSRTemporalCoordinatesValue::getValuePtr | ( |  | ) |
| inlineprotected

get pointer to temporal coordinates value

Returns
  pointer to temporal coordinates value (never NULL)

References DSRTemporalCoordinatesValue().

## ◆ isEqual()

OFBool DSRTemporalCoordinatesValue::isEqual | ( | const DSRTemporalCoordinatesValue & | coordinatesValue | ) | const

check whether values are "equal"

Parameters

  coordinatesValue | temporal coordinates value that should be compared to the current one

Returns
  OFTrue if both temporal coordinates values are equal, OFFalse otherwise

References DSRTemporalCoordinatesValue().

## ◆ isNotEqual()

OFBool DSRTemporalCoordinatesValue::isNotEqual | ( | const DSRTemporalCoordinatesValue & | coordinatesValue | ) | const

check whether values are "not equal"

Parameters

  coordinatesValue | temporal coordinates value that should be compared to the current one

Returns
  OFTrue if both temporal coordinates values are not equal, OFFalse otherwise

References DSRTemporalCoordinatesValue().

## ◆ isShort()

virtual OFBool DSRTemporalCoordinatesValue::isShort | ( | const size_t | flags | ) | const
| virtual

check whether the content is short.

This method is used to check whether the rendered output of this content item can be expanded inline or not (used for renderHTML()).

Parameters

  flags | flag used to customize the output (see DSRTypes::HF_xxx)

Returns
  OFTrue if the content is short, OFFalse otherwise

Reimplemented in DSRTCoordTreeNode.

## ◆ isValid()

virtual OFBool DSRTemporalCoordinatesValue::isValid | ( |  | ) | const
| virtual

check whether the current temporal coordinates value is valid.

The value is valid if the temporal range type is not DSRTypes::TRT_invalid and the other data is valid. See checkData() method for details.

Returns
  OFTrue if reference value is valid, OFFalse otherwise

Reimplemented in DSRTCoordTreeNode.

## ◆ operator=()

DSRTemporalCoordinatesValue & DSRTemporalCoordinatesValue::operator= | ( | const DSRTemporalCoordinatesValue & | coordinatesValue | ) |

assignment operator

Parameters

  coordinatesValue | temporal coordinates value to be copied (not checked !)

Returns
  reference to this temporal coordinates value after 'coordinatesValue' has been copied

References DSRTemporalCoordinatesValue().

## ◆ print()

virtual OFCondition DSRTemporalCoordinatesValue::print | ( | STD_NAMESPACE ostream & | stream,
|  | const size_t | flags ) const
| virtual

print temporal coordinates.

The output of a typical temporal coordinates value looks like this (depending on the referenced data list): (SEGMENT,1,2,3) or (SEGMENT,1,2.5,3.1) or (POINT,20001010120000)

Parameters

  stream | output stream to which the temporal coordinates value should be printed
  flags | flag used to customize the output (see DSRTypes::PF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented in DSRTCoordTreeNode.

## ◆ read()

virtual OFCondition DSRTemporalCoordinatesValue::read | ( | DcmItem & | dataset,
|  | const size_t | flags )
| protectedvirtual

read temporal coordinates value from dataset.

Please note that all three lists are (tried to) read from the dataset. If more than one list is present a warning message is reported.

Parameters

  dataset | DICOM dataset from which the value should be read
  flags | flag used to customize the reading process (see DSRTypes::RF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ readXML()

virtual OFCondition DSRTemporalCoordinatesValue::readXML | ( | const DSRXMLDocument & | doc,
|  | DSRXMLCursor | cursor,
|  | const size_t | flags )
| virtual

read temporal coordinates value from XML document

Parameters

  doc | document containing the XML file content
  cursor | cursor pointing to the starting node
  flags | flag used to customize the reading process (see DSRTypes::XF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ renderHTML()

virtual OFCondition DSRTemporalCoordinatesValue::renderHTML | ( | STD_NAMESPACE ostream & | docStream,
|  | STD_NAMESPACE ostream & | annexStream,
|  | size_t & | annexNumber,
|  | const size_t | flags ) const
| virtual

render temporal coordinates value in HTML/XHTML format

Parameters

  docStream | output stream to which the main HTML/XHTML document is written
  annexStream | output stream to which the HTML/XHTML document annex is written
  annexNumber | reference to the variable where the current annex number is stored. Value is increased automatically by 1 after a new entry has been added.
  flags | flag used to customize the output (see DSRTypes::HF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ setTemporalRangeType()

OFCondition DSRTemporalCoordinatesValue::setTemporalRangeType | ( | const DSRTypes::E_TemporalRangeType | temporalRangeType,
|  | const OFBool | check = OFTrue )

set current temporal range type.

This value represents the type of temporal extent of the region of interest.

Parameters

  temporalRangeType | temporal range type to be set (DSRTypes::TRT_invalid is not allowed)
  check | dummy parameter (currently not used)

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ setValue()

OFCondition DSRTemporalCoordinatesValue::setValue | ( | const DSRTemporalCoordinatesValue & | coordinatesValue,
|  | const OFBool | check = OFTrue )

set temporal coordinates value.

Before setting the value, the temporal range type and other data are checked (see checkData()). If the value is invalid, the current value is not replaced and remains unchanged.

Parameters

  coordinatesValue | value to be set
  check | if enabled, check values for validity before setting them. See checkData() method for details. Empty values are only accepted for non-mandatory attributes.

Returns
  status, EC_Normal if successful, an error code otherwise

References DSRTemporalCoordinatesValue().

## ◆ write()

virtual OFCondition DSRTemporalCoordinatesValue::write | ( | DcmItem & | dataset | ) | const
| protectedvirtual

write temporal coordinates reference value to dataset.

Please note that only one of the three lists is actually written to the dataset.

Parameters

  dataset | DICOM dataset to which the value should be written

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ writeXML()

virtual OFCondition DSRTemporalCoordinatesValue::writeXML | ( | STD_NAMESPACE ostream & | stream,
|  | const size_t | flags ) const
| virtual

write temporal coordinates value in XML format

Parameters

  stream | output stream to which the XML document is written
  flags | flag used to customize the output (see DSRTypes::XF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented in DSRTCoordTreeNode.

The documentation for this class was generated from the following file:

- dcmsr/include/dcmtk/dcmsr/dsrtcovl.h

Generated on Sat Mar 1 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2